## Introduction

[BUW](https://haxe.tuxfamily.org/buw) - Basic and Usefull Widgets is a GUI 
[library](https://lib.haxe.org/p/buw/) for [Haxe](https://haxe.org/) and [OpenFL](https://www.openfl.org/).

Copyright Frank Endres / Éducation Nationale, since 2012.

Released under the [Cecill-C](http://www.cecill.info/licences/Licence_CeCILL-C_V1-en.html) license.

### Features

BUW is a Haxe library providing some controls for the design of a Graphical User Interface (GUI):

- containers: horizontal / vertical boxes and grid,
- widgets: buttons, labels, inputs, checkboxes, radioboxes, spinboxes,
- listviews and tables to display collections of items.

BUW can be used for desktop, mobile and web applications (using OpenFL as backend). 
*Widgets widths are responsive.*


## Usage

### Installation

To install BUW library, run the command:
```sh
haxelib install buw
```

### Project setup

To setup a new OpenFL+BUW project, run the command:
```sh
openfl create project ProjectName
```

Then edit `project.xml` and add the following lines:
```xml
<haxelib name="buw" />
<window width="0" height="0" if="html5" />
```


## Links

- [Zip archives](https://download.tuxfamily.org/haxe/buw/)
- [Git repository](https://git.tuxfamily.org/haxe/buw.git)
```sh
git clone git://git.tuxfamily.org/gitroot/haxe/buw.git
```
