package buw;

import openfl.display.Sprite;

class TextCheckBox extends CheckBox {
	/**
	 * @param listener what to do when checkbox is clicked; defaults to null
	 * @param text the text associated to the checkbox
	 * @param checked the checkbox initial state; defaults to false (unchecked)
	 * @param circle true to draw a circle instead of a square (for radio buttons); defaults to false
	 */
	public function new(?listener : CheckBox -> Void, text : String, ?checked : Bool = false, ?circle : Bool = false) {
		var wh = new Label(" ").textField.height;
		unCheckedSprite = new Sprite();
		unCheckedSprite.graphics.beginFill(Widget.inputBackground);
		unCheckedSprite.graphics.lineStyle(Widget.borderWidth, Widget.borderColor);
		if (circle) {
			unCheckedSprite.graphics.drawCircle(wh / 2, wh / 2, (wh - Widget.borderWidth) / 2);
		} else {
			unCheckedSprite.graphics.drawRect(Widget.borderWidth, Widget.borderWidth, wh - Widget.borderWidth, wh - Widget.borderWidth);
		}
		unCheckedSprite.graphics.endFill();
		checkedSprite = new Sprite();
		checkedSprite.graphics.beginFill(Widget.inputBackground * 8);
		checkedSprite.graphics.lineStyle(Widget.borderWidth, Widget.borderColor);
		if (circle) {
			checkedSprite.graphics.drawCircle(wh / 2, wh / 2, (wh - Widget.borderWidth) / 2);
		} else {
			checkedSprite.graphics.drawRect(Widget.borderWidth, Widget.borderWidth, wh - Widget.borderWidth, wh - Widget.borderWidth);
		}
		checkedSprite.graphics.endFill();
		//toggle = new Toggle(cast listener, checkedSprite, unCheckedSprite, checked);
		super(listener, text, checked); //toggle sprites must be set before
	}
}
