package buw;

//TODO
class ComboBox<T> extends Control {
	public var selected(default, null) : T;
	var vbox : VBox;
	var input : Input;
	var dropDownButton : Button;
	var list : ListView<T>;
	public var source(get, set) : Iterable<T>;

	public function new(?listener : T -> Void, ?renderer : T -> Widget, ?relativeWidth : Float = 1) {
		super(cast listener);
		this.relativeWidth = relativeWidth;
		vbox = new VBox(relativeWidth);
		input = new Input("", 50, relativeWidth);
		vbox.pack(input);

		var wh = input.height - Widget.borderWidth * 3;
		dropDownButton = new Button(showList);
		dropDownButton.graphics.beginFill(Widget.inputBackground);
		dropDownButton.graphics.lineStyle(Widget.borderWidth, Widget.inputBackground);
		dropDownButton.graphics.drawRect(Widget.borderWidth, Widget.borderWidth, wh - Widget.borderWidth, wh - Widget.borderWidth);
		dropDownButton.graphics.endFill();
		dropDownButton.graphics.beginFill(Widget.borderColor);
		dropDownButton.graphics.moveTo(Widget.borderWidth * 3, Widget.borderWidth * 3);
		dropDownButton.graphics.lineTo(wh - Widget.borderWidth * 3, Widget.borderWidth * 3);
		dropDownButton.graphics.lineTo(wh / 2, wh - Widget.borderWidth * 3);
		dropDownButton.graphics.lineTo(Widget.borderWidth * 3, Widget.borderWidth * 3);
		dropDownButton.graphics.endFill();
		dropDownButton.y = Widget.borderWidth * 2;
		vbox.addChild(dropDownButton);

		list = new ListView<T>(renderer, listener, 1, -1);

		addChild(vbox);
	}

	override public function draw() {
		input.draw();
		input.textField.width -= dropDownButton.width - Widget.horizontalPadding;
		//vbox.placeWidgets();
		dropDownButton.x = vbox.getWidth() - dropDownButton.width - Widget.horizontalPadding;
	}

	function get_source() : Iterable<T> {
		return list.source;
	}

	function set_source(source : Iterable<T>) : Iterable<T> {
		return list.source = source;
	}

	function showList(w : Button) {
		vbox.pack(list);
	}
}
