//import openfl.Lib;
import openfl.display.Sprite;
import buw.*;

class Book {
	public var author : String;
	public var title : String;
	public function new(t : String, a : String) {
		author = a;
		title = t;
	}

	public function toString() : String {
		return title + ": " + author;
	}
}

class Demo extends Sprite {
	var rootWindow : VBox;
	var rdb : RadioBox;
	var firstname : Input;
	var lastname : Input;
	#if js
	var messages : VBox;
	#end

	/*public static function main() {
		Lib.current.stage.addChild(new Main());
	}*/

	public function new () {
		super ();
		rootWindow = new VBox(1, -1);

		#if js
		rootWindow.pack(new Title("Log messages :"));
		messages = new VBox();
		rootWindow.pack(messages);
		rootWindow.pack(new Separator());
		#end
		rootWindow.pack(new Title("Widgets demo: "));

		var g : Grid = new Grid(1, [new HBoxColumn(0.3), new HBoxColumn(0.7)]);
		g.pack(new Label("Firstname:"));
		g.pack(firstname = new Input(20));
		g.pack(new Label("Lastname:"));
		g.pack(lastname = new Input(20));
		rootWindow.pack(g);
		rootWindow.pack(new TextButton(function (w : TextButton) { displayLog(firstname.value + " " + lastname.value); }, "Retrieve inputs"));

		rootWindow.pack(new Separator());
		rootWindow.pack(new TextCheckBox(function(cb : CheckBox) { displayLog(Std.string(cb.checked)); }, "checkbox", true));
		rootWindow.pack(new TextSpinBox(null, "spinbox"));

		rootWindow.pack(new Separator());
		var hb1 = new HBox(1, [new HBoxColumn(0.5), new HBoxColumn(0.5)]);
		rootWindow.pack(hb1);
		hb1.pack(new TextButton(function (w : TextButton) { displayLog(Std.string(rdb.selected)); }, "Button GetRadio", 0.4));
		hb1.pack(new TextButton(function (w : TextButton) { rdb.selected = (rdb.selected + 1) % 2; }, "Button SetRadio", 0.4));
		rdb = new RadioBox(function (w : RadioBox) { displayLog("selected is " + w.selected); }, true);
		rdb.add(new TextRadioButton("val 1", true));
		rdb.add(new TextRadioButton("val 2", false));
		rootWindow.pack(rdb);

		var hb3 = new HBox(1);
		hb3.pack(new Image("assets/openfl.png", 0.15));
		hb3.pack(new Image("assets/haxe.png", 50));
		rootWindow.pack(hb3);

		rootWindow.pack(new Separator());
		rootWindow.pack(new TextButton(cbListView, "Load ListView"));
		rootWindow.pack(new TextButton(cbTable, "Load Table"));

		Screen.display(rootWindow);
	}

	function cbListView(w : TextButton) {
		rootWindow.pack(new Separator());
		rootWindow.pack(new Title("ListView content:"));
		var books : List<Book> = new List();
		books.add(new Book("Les misérables", "Victor Hugo"));
		books.add(new Book("20 000 lieues sous les mers", "Jules Verne"));
		//~ var list : ListView<Book> = new ListView(function(o : Book) : Widget { return new Label(o.title + " - " + o.author); },
			//~ function (o : Book) { displayLog(o.title); });
		var list = new ListView<Book>(function (o : Book) : Void { displayLog(o.author); });
		list.source = books;
		rootWindow.pack(list);
	}

	function cbTable(w : TextButton) {
		rootWindow.pack(new Separator());
		var books : Array<Book> = new Array();
		books.push(new Book("La Horde du contrevent", "Alain Damasio"));
		books.push(new Book("La fraternité du Panca", "Pierre Bordage"));
		var table : Table<Book> = new Table(function (o : Book) { displayLog(o.title); }, 1,
			[new TableColumn(0.65, "Title", "title"), new TableColumn(0.35, "Author", "author")]);
		table.source = books;
		table.push(new Book("Ravage", "Barjavel"));
		rootWindow.pack(table);
	}

	function displayLog(text : String) {
		#if js
		messages.pack(new Label(text));
		#else
		Sys.println(text);
		#end
	}
}
